# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, conlist
from getopenpay.models.currency_enum import CurrencyEnum
from getopenpay.models.currency_filter_type import CurrencyFilterType

class CurrencyFilter(BaseModel):
    """
    CurrencyFilter
    """
    currencies: conlist(CurrencyEnum) = Field(default=..., description="The list of currencies to filter by according to the filter_type.")
    filter_type: CurrencyFilterType = Field(default=..., description="The type of filter to apply. Possible values: \"include\" and \"exclude\"")
    __properties = ["currencies", "filter_type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CurrencyFilter:
        """Create an instance of CurrencyFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CurrencyFilter:
        """Create an instance of CurrencyFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CurrencyFilter.parse_obj(obj)

        _obj = CurrencyFilter.parse_obj({
            "currencies": obj.get("currencies"),
            "filter_type": obj.get("filter_type")
        })
        return _obj


